<template>
  <div class="barca" :style="{ '--border-color': borderColor }">
    <header>
      <router-link tag="h3" :to="`/barcas/${barca.id}`">{{
        barca.nombre
      }}</router-link>
      <div class="buttons" v-if="!barca.abordada">
        <button class="circle" @click="e => abordarBarca(barca.id)">
          <InIcono />
        </button>
      </div>
    </header>
    <template v-if="barca.abordada">
      <ul v-if="consensosMostrados" :class="{ 'is-loading': loading }">
        <li v-for="consenso in consensosMostrados">
          <p>
            <a :href="`#/barcas/${barca.id}/consensos/${consenso.id}`">{{
              consenso.titulo
            }}</a>
          </p>
        </li>
      </ul>
    </template>
    <template v-else>
      <p>{{ barca.descripcion }}</p>
    </template>
    <hr />
  </div>
</template>

<script>
import { mapState } from 'vuex'

import InIcono from '@/assets/iconos/in.svg?inline'
import LoadingIcono from '@/assets/iconos/loading.svg?inline'

export default {
  name: 'Barca',
  props: ['barca', 'borderColor', 'updateKey'],
  components: { InIcono, LoadingIcono },
  data() {
    return { loading: false }
  },
  computed: {
    ...mapState(['consensos']),
    consensosMostrados() {
      if (!this.consensos) return null
      const consensos = this.consensos.filter(
        consenso => consenso.barca_id == this.barca.id,
      )
      return consensos.slice(consensos.length - 3)
    },
  },
  methods: {
    refrescar() {
      if (this.barca.abordada) {
        this.loading = true
        return this.$store
          .dispatch('conseguirConsensos', {
            barcaId: this.barca.id,
          })
          .finally(() => (this.loading = false))
      } else {
        this.loading = false
      }
    },
    abordarBarca(id) {
      this.$store
        .dispatch('abordarBarca', { barcaId: id })
        .catch(error => this.$emit('error', error))
    },
  },
  mounted() {
    this.refrescar()
  },
  watch: {
    updateKey() {
      this.refrescar()
    },
  },
}
</script>

<style lang="sass" scoped>
.barca
  header
    display: block
    h3
      text-transform: uppercase
      color: var(--verydarkgray)
      cursor: pointer
      display: inline-block
    .buttons
      float: right
  p
    margin: 0
  hr
    border-color: var(--gray)
    border-bottom: none
    margin: 10px 40px
  //padding-bottom: .7em
  ul
    padding: 0
    margin: 0
    list-style: none
    &.is-loading
      opacity: .5
    li
      padding-left: .5em
      border-left: 4px solid var(--border-color)
      margin: .4em .2em
      p
        margin: 0
        max-height: 3em
        line-height: 1
        a
          color: inherit
          text-decoration: none
          &:hover
            text-decoration: underline
</style>
